## nvidia-graphics-drivers-550 550.67

=== kernel-open/Makefile ===
#
# This Makefile was automatically generated; do not edit.
#

###########################################################################
# Makefile for NVIDIA Linux GPU driver kernel modules
###########################################################################

# This makefile is read twice: when a user or nvidia-installer invokes
# 'make', this file is read.  It then invokes the Linux kernel's
# Kbuild.  Modern versions of Kbuild will then read the Kbuild file in
# this directory.  However, old versions of Kbuild will instead read
# this Makefile.  For backwards compatibility, when read by Kbuild
# (recognized by KERNELRELEASE not being empty), do nothing but
# include the Kbuild file in this directory.

ifneq ($(KERNELRELEASE),)
  include $(src)/Kbuild
else

  # Determine the location of the Linux kernel source tree, and of the
  # kernel's output tree.  Use this to invoke Kbuild, and pass the paths
  # to the source and output trees to NVIDIA's Kbuild file via
  # NV_KERNEL_{SOURCES,OUTPUT}.

  ifdef SYSSRC
    KERNEL_SOURCES := $(SYSSRC)
  else
    KERNEL_UNAME ?= $(shell uname -r)
    KERNEL_MODLIB := /lib/modules/$(KERNEL_UNAME)
    KERNEL_SOURCES := $(shell test -d $(KERNEL_MODLIB)/source && echo $(KERNEL_MODLIB)/source || echo $(KERNEL_MODLIB)/build)
  endif

  KERNEL_OUTPUT := $(KERNEL_SOURCES)
  KBUILD_PARAMS :=

  ifdef SYSOUT
    ifneq ($(SYSOUT), $(KERNEL_SOURCES))
      KERNEL_OUTPUT := $(SYSOUT)
      KBUILD_PARAMS := KBUILD_OUTPUT=$(KERNEL_OUTPUT)
    endif
  else
    KERNEL_UNAME ?= $(shell uname -r)
    KERNEL_MODLIB := /lib/modules/$(KERNEL_UNAME)
    ifeq ($(KERNEL_SOURCES), $(KERNEL_MODLIB)/source)
      KERNEL_OUTPUT := $(KERNEL_MODLIB)/build
      KBUILD_PARAMS := KBUILD_OUTPUT=$(KERNEL_OUTPUT)
    endif
  endif

  CC ?= cc
  LD ?= ld
  OBJDUMP ?= objdump

  ifndef ARCH
    ARCH := $(shell uname -m | sed -e 's/i.86/i386/' \
      -e 's/armv[0-7]\w\+/arm/' \
      -e 's/aarch64/arm64/' \
      -e 's/ppc64le/powerpc/' \
      -e 's/riscv64/riscv/' \
    )
  endif

  NV_KERNEL_MODULES ?= $(wildcard nvidia nvidia-uvm nvidia-vgpu-vfio nvidia-modeset nvidia-drm nvidia-peermem)
  NV_KERNEL_MODULES := $(filter-out $(NV_EXCLUDE_KERNEL_MODULES), \
                                    $(NV_KERNEL_MODULES))
  INSTALL_MOD_DIR ?= kernel/drivers/video

  NV_VERBOSE ?=
  SPECTRE_V2_RETPOLINE ?= 0

  ifeq ($(NV_VERBOSE),1)
    KBUILD_PARAMS += V=1
  endif
  KBUILD_PARAMS += -C $(KERNEL_SOURCES) M=$(CURDIR)
  KBUILD_PARAMS += ARCH=$(ARCH)
  KBUILD_PARAMS += NV_KERNEL_SOURCES=$(KERNEL_SOURCES)
  KBUILD_PARAMS += NV_KERNEL_OUTPUT=$(KERNEL_OUTPUT)
  KBUILD_PARAMS += NV_KERNEL_MODULES="$(NV_KERNEL_MODULES)"
  KBUILD_PARAMS += INSTALL_MOD_DIR="$(INSTALL_MOD_DIR)"
  KBUILD_PARAMS += NV_SPECTRE_V2=$(SPECTRE_V2_RETPOLINE)

  .PHONY: modules module clean clean_conftest modules_install
  modules clean modules_install:
	@$(MAKE) "LD=$(LD)" "CC=$(CC)" "OBJDUMP=$(OBJDUMP)" $(KBUILD_PARAMS) $@
	@if [ "$@" = "modules" ]; then \
	  for module in $(NV_KERNEL_MODULES); do \
	    if [ -x split-object-file.sh ]; then \
	      ./split-object-file.sh $$module.ko; \
	    fi; \
	  done; \
	fi

  # Compatibility target for scripts that may be directly calling the
  # "module" target from the old build system.

  module: modules

  # Check if the any of kernel module linker scripts exist. If they do, pass
  # them as linker options (via variable NV_MODULE_LD_SCRIPTS) while building
  # the kernel interface object files. These scripts do some processing on the
  # module symbols on which the Linux kernel's module resolution is dependent
  # and hence must be used whenever present.

  LD_SCRIPT ?= $(KERNEL_SOURCES)/scripts/module-common.lds      \
               $(KERNEL_SOURCES)/arch/$(ARCH)/kernel/module.lds \
               $(KERNEL_OUTPUT)/scripts/module.lds
  NV_MODULE_COMMON_SCRIPTS := $(foreach s, $(wildcard $(LD_SCRIPT)), -T $(s))

  # Use $* to match the stem % in the kernel interface file %-linux.o. Replace
  # "nv" with "nvidia" in $* as appropriate: e.g. nv-modeset-linux.o links
  # nvidia-modeset.mod.o and nvidia-modeset/nv-modeset-interface.o. The kernel
  # interface file must have the .mod.o object linked into it: otherwise, the
  # kernel module produced by linking the interface against its corresponding
  # core object file will not be loadable. The .mod.o file is built as part of
  # the MODPOST process (stage 2),  so the rule to build the kernel interface
  # cannot be defined in the *Kbuild files, which are only used during stage 1.

  %-linux.o: modules
	$(LD) $(NV_MODULE_COMMON_SCRIPTS) -r -o $@ \
	  $(subst nv,nvidia,$*).mod.o $(subst nv,nvidia,$*)/$*-interface.o

  # Kbuild's "clean" rule won't clean up the conftest headers on its own, and
  # clean-dirs doesn't appear to work as advertised.
  clean_conftest:
	$(RM) -r conftest
  clean: clean_conftest

endif # KERNELRELEASE

=== debian/changelog ===
nvidia-graphics-drivers-550 (550.67-0ubuntu3) noble; urgency=medium

  * Limit supported pci-id's to the new ones supported by this release.
    (LP: #2061830)

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 16 Apr 2024 13:37:41 +0300

nvidia-graphics-drivers-550 (550.67-0ubuntu2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 06:35:15 +0000

nvidia-graphics-drivers-550 (550.67-0ubuntu1) noble; urgency=medium

  * Initial release (LP: #2055384)

 -- Kuba Pawlak <kuba.pawlak@canonical.com>  Tue, 19 Mar 2024 20:50:29 +0100

=== debian/control ===
Source: nvidia-graphics-drivers-550
Section: non-free/libs
Priority: optional
Maintainer: Ubuntu Core Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Uploaders:
 Alberto Milone <alberto.milone@canonical.com>,
Vcs-Git: git://github.com/canonical/nvidia-graphics-drivers.git
Vcs-Browser: https://github.com/canonical/nvidia-graphics-drivers/tree/550
Build-Depends:
 debhelper (>= 12),
 dpkg-dev (>= 1.17.11~),
 xz-utils,
 zstd,
 dkms,
 libxext6,
 po-debconf,
 dh-modaliases,
 xserver-xorg-dev (>= 2:1.4),
 libglvnd-dev,
 libkmod-dev,
 libpciaccess-dev,
 pkg-config,
 libnvidia-egl-wayland1,
 libc6,
 libx11-6,
 python3,
Standards-Version: 4.1.1
Homepage: http://www.nvidia.com
XS-Autobuild: yes

Package: nvidia-driver-550
Architecture: amd64 arm64
Depends:
 libnvidia-gl-550 (= ${binary:Version}),
 nvidia-dkms-550 (<= 550.67-1),
 nvidia-dkms-550 (>= 550.67),
 nvidia-kernel-common-550 (<= 550.67-1),
 nvidia-kernel-common-550 (>= 550.67),
 nvidia-kernel-source-550 (= ${binary:Version}),
 libnvidia-compute-550 (= ${binary:Version}),
 libnvidia-extra-550 (= ${binary:Version}),
 nvidia-compute-utils-550 (= ${binary:Version}),
 libnvidia-decode-550 (= ${binary:Version}),
 libnvidia-encode-550 (= ${binary:Version}),
 nvidia-utils-550 (= ${binary:Version}),
 xserver-xorg-video-nvidia-550 (= ${binary:Version}),
 libnvidia-cfg1-550 (= ${binary:Version}),
 libnvidia-fbc1-550 (= ${binary:Version}) [!ppc64el],
 ${misc:Depends}
Recommends:
 nvidia-settings, nvidia-prime (>= 0.8),
 libnvidia-compute-550:i386 (= ${binary:Version}) [amd64],
 libnvidia-decode-550:i386 (= ${binary:Version}) [amd64],
 libnvidia-encode-550:i386 (= ${binary:Version}) [amd64],
 libnvidia-fbc1-550:i386 (= ${binary:Version}) [amd64],
 libnvidia-gl-550:i386 (= ${binary:Version}) [amd64]
XB-Modaliases: ${modaliases}
XB-PmAliases: ${nvidia:pm-modaliases}
XB-Support: PB
Description: NVIDIA driver metapackage
 This metapackage depends on the NVIDIA binary driver and on all of its libraries,
 to provide hardware acceleration for OpenGL/GLX/EGL/GLES/Vulkan
 applications on either X11 or on Wayland.
 .
 See /usr/share/doc/nvidia-driver-550/README.txt.gz
 for a complete list of supported GPUs and PCI IDs.

Package: nvidia-kernel-source-550
Architecture: amd64 arm64
Multi-Arch: foreign
Conflicts:
 nvidia-kernel-source
Replaces:
 nvidia-kernel-source, nvidia-384 (<< 390.25), nvidia-390 (<< 390.25-0ubuntu1)
Provides:
 nvidia-kernel-source
Depends:
 ${misc:Depends}, ${shlibs:Depends}
Description: NVIDIA kernel source package
 This package provides the NVIDIA kernel source needed by the userspace
 driver.

Package: nvidia-dkms-550
Architecture: amd64 arm64
Multi-Arch: foreign
Conflicts:
 nvidia-dkms-kernel
Breaks: nvidia-kernel-source-550 (<< 390.25-0ubuntu2~)
Replaces:
 nvidia-dkms-kernel, nvidia-kernel-source-550 (<< 390.25-0ubuntu2~), nvidia-384 (<< 390.25)
Provides:
 nvidia-dkms-kernel
Depends:
 dkms,
 nvidia-kernel-source-550 (<= 550.67-1),
 nvidia-kernel-source-550 (>= 550.67),
 nvidia-kernel-common-550 (<= 550.67-1),
 nvidia-kernel-common-550 (>= 550.67),
 nvidia-firmware-550-550.67,
 ${misc:Depends}, ${shlibs:Depends}
Description: NVIDIA DKMS package
 This package builds the NVIDIA kernel module needed by the userspace
 driver, using DKMS.
 Provided that you have the kernel header packages installed, the kernel
 module will be built for your running kernel, and automatically rebuilt for
 any new kernel headers that are installed.

Package: nvidia-utils-550
Architecture: amd64 arm64
Depends:
 ${shlibs:Depends}, ${misc:Depends}
Suggests:
 nvidia-driver-550,
Provides:
 nvidia-utils, nvidia-smi
Conflicts:
 nvidia-utils, nvidia-smi
Replaces:
 nvidia-utils, nvidia-smi
Description: NVIDIA driver support binaries
 This package contains supporting binaries for the NVIDIA driver.

Package: libnvidia-compute-550
Architecture: i386 amd64 arm64
Multi-Arch: same
Depends:
  ${misc:Depends}, ${shlibs:Depends}
Provides: libnvidia-compute, nvidia-opencl-icd, opencl-icd, libnvidia-ml.so.1 (= ${source:Version}),
 libcuda-5.0-1, libcuda-5.5-1, libcuda-6.0-1, libcuda-6.5-1,
 libcuda-7.0-1, libcuda-7.5-1, libcuda-8.0-1, libcuda-9.0-1,
 libcuda-9.1-1, libcuda-9.2-1, libcuda-10.0-1, libcuda-10.1-1,
 libcuda-10.2-1, libcuda-11.0-1, libcuda-11.1-1, libcuda-11.2-1,
 libcuda-11.3-1, libcuda-11.4-1, libcuda-11.5-1, libcuda-11.6-1,
 libcuda-11.7-1,
 libcuda.so.1 (= ${source:Version})
Conflicts: libnvidia-compute, nvidia-opencl-icd,
 libcuda-5.0-1, libcuda-5.5-1, libcuda-6.0-1, libcuda-6.5-1,
 libcuda-7.0-1, libcuda-7.5-1, libcuda-8.0-1, libcuda-9.0-1,
 libcuda-9.1-1, libcuda-9.2-1, libcuda-10.0-1, libcuda-10.1-1,
 libcuda-10.2-1, libcuda-11.0-1, libcuda-11.1-1, libcuda-11.2-1,
 libcuda-11.3-1, libcuda-11.4-1, libcuda-11.5-1, libcuda-11.6-1,
 libcuda-11.7-1
Replaces: libnvidia-compute, nvidia-opencl-icd, libnvidia-compute-550 (<< 390.25-0ubuntu2~),
 libcuda-5.0-1, libcuda-5.5-1, libcuda-6.0-1, libcuda-6.5-1,
 libcuda-7.0-1, libcuda-7.5-1, libcuda-8.0-1, libcuda-9.0-1,
 libcuda-9.1-1, libcuda-9.2-1, libcuda-10.0-1, libcuda-10.1-1,
 libcuda-10.2-1, libcuda-11.0-1, libcuda-11.1-1, libcuda-11.2-1,
 libcuda-11.3-1, libcuda-11.4-1, libcuda-11.5-1, libcuda-11.6-1,
 libcuda-11.7-1
Description: NVIDIA libcompute package
 This package provides a set of libraries which enable the NVIDIA driver
 to use GPUs for parallel general purpose computation through CUDA and
 OpenCL.

Package: nvidia-compute-utils-550
Architecture: amd64 arm64
Depends:
 libnvidia-compute-550, adduser,
 ${misc:Depends}, ${shlibs:Depends}
Provides: nvidia-compute-utils, nvidia-persistenced
Conflicts: nvidia-compute-utils, nvidia-persistenced
Replaces: nvidia-compute-utils, nvidia-persistenced
Description: NVIDIA compute utilities
 This package provides utility binaries for paraller general purpose
 computing use cases with the NVIDIA driver.
 .
 CUDA MPS is a feature that allows multiple CUDA processes to share a single
 GPU context. CUDA MPS should be transparent to CUDA programs.
 .
 CUDA MPS requires a device that supports Unified Virtual Address (UVA) and
 has compute capability SM 3.5 or higher.
 Pre-CUDA 4.0 APIs are not supported under CUDA MPS.

Package: nvidia-headless-no-dkms-550
Architecture: amd64 arm64
Conflicts: nvidia-384 (<< 390.25), nvidia-390 (<< 390.25-0ubuntu1)
Provides: nvidia-384
Replaces: nvidia-384 (<< 390.25), nvidia-390 (<< 390.25-0ubuntu1)
Depends:
 nvidia-kernel-common-550 (<= 550.67-1),
 nvidia-kernel-common-550 (>= 550.67),
 nvidia-kernel-source-550 (= ${binary:Version}),
 libnvidia-compute-550 (= ${binary:Version}),
 nvidia-compute-utils-550 (= ${binary:Version}),
 libnvidia-cfg1-550 (= ${binary:Version}),
 ${misc:Depends}, ${shlibs:Depends}
Description: NVIDIA headless metapackage - no DKMS
 This metapackage installs the NVIDIA driver and the libraries that enable
 parallel general purpose computation through CUDA and
 OpenCL. DKMS will not be installed, and, therefore, the kernel module
 will not be built.
 .
 Install this package if you do not need X11 or Wayland support, which is
 provided by the nvidia-driver-550 metapackage.

Package: nvidia-headless-550
Architecture: amd64 arm64
Conflicts: nvidia-headless
Provides: nvidia-headless
Replaces: nvidia-headless
Depends:
 nvidia-headless-no-dkms-550,
 nvidia-dkms-550,
 ${misc:Depends}, ${shlibs:Depends}
Description: NVIDIA headless metapackage
 This metapackage installs the NVIDIA driver and the libraries that enable
 parallel general purpose computation through CUDA and
 OpenCL.
 .
 Install this package if you do not need X11 or Wayland support, which is
 provided by the nvidia-driver-550 metapackage.

Package: nvidia-kernel-common-550
Architecture: amd64 arm64
Conflicts: nvidia-kernel-common
Provides: nvidia-kernel-common
Depends:
 ${misc:Depends}, ${shlibs:Depends}, nvidia-firmware-550-550.67
Replaces:
 nvidia-dkms-550 (<< 390.48-0ubuntu3~), nvidia-kernel-common
Description: Shared files used with the kernel module
 This package installs all the optional accessory files for the NVIDIA
 kernel module.
 .
 Install this package if you want to blacklist any conflicting kernel
 modules, and if you want udev to load the the NVIDIA kernel modules,
 and to create the uvm devices automatically.

Package: nvidia-firmware-550-550.67
Architecture: amd64 arm64
Breaks:
 nvidia-firmware-550-server-550.67
Replaces:
 nvidia-firmware-550-server-550.67
Depends:
 ${misc:Depends}
Description: Firmware files used by the kernel module
 This package installs required firmware files for the NVIDIA kernel
 module.

Package: libnvidia-gl-550
Architecture: i386 amd64 arm64
Multi-Arch: same
Conflicts: libnvidia-gl
Replaces: libnvidia-gl, nvidia-384 (<< 390.25), nvidia-390 (<< 390.25-0ubuntu1)
Provides: libnvidia-gl, libglx-vendor, libegl-vendor
Depends:
 libnvidia-common-550, ${misc:Depends}, ${shlibs:Depends}
Description: NVIDIA OpenGL/GLX/EGL/GLES GLVND libraries and Vulkan ICD
 This package provides the NVIDIA OpenGL/GLX/EGL/GLES libraries and the
 Vulkan ICD.

Package: libnvidia-common-550
Architecture: all
Multi-Arch: foreign
Breaks: libnvidia-gl-550 (<< 390.25-0ubuntu2~)
Conflicts: libnvidia-common
Replaces: libnvidia-common, libnvidia-gl-550 (<< 390.25-0ubuntu2~)
Provides: libnvidia-common
Depends:
 ${misc:Depends}, ${shlibs:Depends}
Description: Shared files used by the NVIDIA libraries
 This package provides a set of files that are required by the NVIDIA
 libraries.

Package: libnvidia-extra-550
Architecture: i386 amd64 arm64
Multi-Arch: same
Breaks: libnvidia-common-550 (<< 440.64-0ubuntu3~)
Conflicts: libnvidia-extra
Replaces: libnvidia-extra, libnvidia-common-550 (<< 440.64-0ubuntu3~)
Provides: libnvidia-extra
Depends:
 ${misc:Depends}, ${shlibs:Depends}
Description: Extra libraries for the NVIDIA driver
 This package provides an additional set of libraries to be used with
 the NVIDIA driver.

Package: xserver-xorg-video-nvidia-550
Section: non-free/x11
Architecture: amd64 arm64
Depends:
 libnvidia-cfg1-550 (= ${binary:Version}),
 ${nvidia:xorgDepends},
 ${shlibs:Depends}, ${misc:Depends}
Conflicts: xorg-driver-binary, nvidia-driver-binary
Replaces: xorg-driver-binary, nvidia-driver-binary
Provides:
 xorg-driver-binary, nvidia-driver-binary,
 ${nvidia:xorgProvides}
Description: NVIDIA binary Xorg driver
 The NVIDIA binary driver provides optimized hardware acceleration of
 OpenGL/GLX/EGL/GLES applications via a direct-rendering X Server
 for graphics cards using NVIDIA chip sets.
 .
 See /usr/share/doc/nvidia-driver-550/README.txt.gz
 for a complete list of supported GPUs and PCI IDs.

Package: libnvidia-cfg1-550
Architecture: amd64 arm64
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 ${shlibs:Depends}, ${misc:Depends}
Provides:
 libnvidia-cfg1-any,
Conflicts:
 libnvidia-cfg1-any,
Replaces:
 libnvidia-cfg1-any,
Description: NVIDIA binary OpenGL/GLX configuration library
 The NVIDIA binary driver provides optimized hardware acceleration of
 OpenGL/GLX/EGL/GLES applications via a direct-rendering X Server
 for graphics cards using NVIDIA chip sets.
 .
 This package contains the libnvidia-cfg.so.1 runtime library.

Package: libnvidia-fbc1-550
Architecture: i386 amd64 arm64
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
# ${nvidia}-alternative (= ${binary:Version}),
 ${shlibs:Depends}, ${misc:Depends}
Provides:
 libnvidia-fbc1,
Conflicts:
 libnvidia-fbc1,
Replaces:
 libnvidia-fbc1,
Description: NVIDIA OpenGL-based Framebuffer Capture runtime library
 The NVIDIA OpenGL-based Framebuffer Capture (NvFBCOpenGL) library provides
 a high performance, low latency interface to capture and optionally encode an
 OpenGL framebuffer. NvFBCOpenGL is a private API that is only available to
 approved partners for use in remote graphics scenarios.
 .
 This package contains the NvFBCOpenGL runtime library.

Package: libnvidia-decode-550
Architecture: i386 amd64 arm64
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 libnvidia-compute-550 (= ${binary:Version}),
 ${shlibs:Depends}, ${misc:Depends}
Conflicts:

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export NO_DOC_PKG_MANGLE=1

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

include debian/rules.defs
XORG_ABI_LIST		?=
XORG_BOUND		?=

version			= $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e's/.*\+really\.//')
debian_version	= $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e's/.*\+really\.//')
NVIDIA_RELEASE   = $(version)
version_major		 = $(firstword $(subst ., ,$(version)))

# system libdir
libdir			?= usr/lib/$(DEB_HOST_MULTIARCH)

last_suffix            := $(lastword $(subst -, ,$(DEB_SOURCE)))
ifeq ($(last_suffix),server)
flavour := $(version_major)-server
other_flavour := $(version_major)
else
flavour := $(version_major)
other_flavour := $(version_major)-server
endif
pkg_meta         := nvidia-driver-$(flavour)
pkg_meta_open    := $(pkg_meta)-open
pkg_driver       := nvidia-$(flavour)
xorg_driver      := xserver-xorg-video-nvidia-$(flavour)
#pkg_module       := $(shell echo "$(pkg_driver)" | sed s/\-/_/g)
pkg_module       := nvidia
pkg_kernel       := nvidia-kernel-$(flavour)

ifeq ($(DEB_HOST_ARCH),amd64)
DKMS_disabled_modules :=
amd64_only :=
amd64_excluded := \#
else
amd64_only := \#
amd64_excluded :=
endif

ifeq ($(DEB_HOST_ARCH),i386)
DKMS_disabled_modules := nvidia-uvm
i386_only :=
i386_excluded := \#
else
i386_only := \#
i386_excluded :=
endif

ifeq ($(DEB_HOST_ARCH),armhf)
DKMS_disabled_modules := nvidia-uvm
armhf_only :=
armhf_excluded := \#
else
armhf_only := \#
armhf_excluded :=
endif

ifeq ($(DEB_HOST_ARCH),arm64)
DKMS_disabled_modules :=
arm64_only :=
arm64_excluded := \#
else
arm64_only := \#
arm64_excluded :=
endif

ifeq ($(DEB_HOST_ARCH),ppc64el)
DKMS_disabled_modules :=
ppc64el_only :=
ppc64el_excluded := \#
else
ppc64el_only := \#
ppc64el_excluded :=
endif

# i386 binaries are shipped in amd64
# Or could use ARCH_LIST to unpack all arches
ifeq ($(DEB_HOST_ARCH),i386)
unpack-stamp: NVIDIA-Linux-amd64
else
unpack-stamp: NVIDIA-Linux-$(DEB_HOST_ARCH)
endif

comma		 = ,
xorg_depends	 = $(foreach abi, $(XORG_ABI_LIST), xorg-video-abi-$(abi) |)
xorg_depends	+= $(comma) xserver-xorg-core $(XORG_BOUND)
xorg_provides	 = xorg-driver-video


.PHONY: prepare patch
prepare: unpack-stamp compare-copyright-license
patch: prepare

NVIDIA-Linux-%:
	sh $*/${NVIDIA_FILENAME_$*} --extract-only
	ln -s ${NVIDIA_DIRNAME_$*} $@
	ln -s $@ NVIDIA-Linux
	#gunzip $@/*.1.gz

# Unpack all architectures, we may need files from all of them.
unpack-stamp:
	dh_testdir
	#QUILT_PATCHES=debian/patches QUILT_SERIES=series-postunpack quilt --quiltrc /dev/null push -a || test $$? = 2
	ls -al
	touch $@

# Reformat the LICENSE to the format needed for debian/copyright.
LICENSE.txt: unpack-stamp
	sed -e 's/^ *//; s/ *$$//; s/^$$/./; s/^/ /;' NVIDIA-Linux/LICENSE > $@

# Compare the license in debian/copyright with the LICENSE shipped in the archive.
compare-copyright-license: LICENSE.txt
	sed -e '1,/^License: NVIDIA-graphics-drivers/d; 1,/^License: NVIDIA-graphics-drivers$$/d; /^$$\|^Comment:$$/,$$d; /^ \.$$/d' debian/copyright > copyright.tmp
	sed -e '/^ \.$$/d' LICENSE.txt > LICENSE.tmp
	diff -w copyright.tmp LICENSE.tmp
	rm -f copyright.tmp LICENSE.tmp

build-device-create:
	rm -f $(CURDIR)/debian/device-create/ub-device-create
	cd $(CURDIR)/debian/device-create/ && $(MAKE) all || exit 1
	@echo "ub-device-create built"

%:
	dh $@

override_dh_auto_clean:
	rm -fr .pc
	rm -f NVIDIA-Linux
	rm -fr $(foreach a,$(ARCH_LIST),NVIDIA-Linux-$a $(NVIDIA_DIRNAME_$a))
	rm -fr kernel-source-tree
	rm -f nvidia.ids nv-kernel.ids nv-readme.ids pci.ids.nvidia*
	rm -f debian/runtimepm_ids
	rm -f LICENSE.txt LICENSE.tmp copyright.tmp
	test ! -d debian/po || debconf-updatepo
	rm -f debian/$(pkg_driver).substvars
	rm -f debian/dkms.conf
	rm -f debian/device-create/ub-device-create

override_dh_clean: regen-from-templates
	dh_clean

override_dh_auto_configure: prepare regen-from-templates

override_dh_compress:
	dh_compress -Xsupported-gpus.json

override_dh_install: generate-modaliases build-device-create
	# Use our custom dkms.conf file
	cp -f $(CURDIR)/debian/dkms_nvidia.conf $(CURDIR)/debian/dkms.conf
	cp -f $(CURDIR)/debian/dkms_nvidia_open.conf $(CURDIR)/debian/open-kernel/dkms.conf

ifeq (,$(findstring nvidia-uvm,$(DKMS_disabled_modules)))
	# Make sure the UVM module is built
	cat $(CURDIR)/debian/dkms.conf.fragment >> $(CURDIR)/debian/dkms.conf
	cat $(CURDIR)/debian/dkms.conf.fragment >> $(CURDIR)/debian/open-kernel/dkms.conf
endif

	dh_install -p nvidia-compute-utils-$(version_major)
	mkdir -p $(CURDIR)/debian/nvidia-compute-utils-$(version_major)/lib/systemd
	dh_installsystemd --name=nvidia-persistenced --no-start --no-stop-on-upgrade --no-restart-after-upgrade
	dh_install -p nvidia-kernel-common-$(version_major)

	mkdir -p $(CURDIR)/debian/nvidia-kernel-common-$(version_major)/lib/systemd
	dh_installsystemd --name=nvidia-hibernate --no-start --no-stop-on-upgrade --no-restart-after-upgrade
	dh_installsystemd --name=nvidia-resume --no-start --no-stop-on-upgrade --no-restart-after-upgrade
	dh_installsystemd --name=nvidia-suspend --no-start --no-stop-on-upgrade --no-restart-after-upgrade

	dh_install

override_dh_installinit:
	dh_installinit --noscripts

override_dh_shlibdeps:
	LD_LIBRARY_PATH=/$(libdir):$(LD_LIBRARY_PATH) dh_shlibdeps -Xlibnvidia-pkcs11.so

override_dh_installsystemd:

############################################################################

.PHONY: regen-from-templates
regen-from-templates:
	# Get rid of files belonging to different flavours
	for i in debian/templates/*.in; do \
		old=`echo $$i | sed -e "s|templates\/||g" | \
				sed -e "s|\.in\$$||g" | \
				sed -e "s|nvidia-graphics-drivers|nvidia-*|g" | \
				sed -e "s|version|*|g" | \
				sed -e "s|flavour|*|g"`; \
		rm -f $$old; done
	# Create important strings
	for i in debian/templates/*.in; do \
		dest=`echo $$i | sed -e "s|templates\/||g" | \
				 sed -e "s|\.in\$$||g" | \
				 sed -e "s|version|$(version)|g" | \
				 sed -e "s|flavour|$(flavour)|g"`; \
		sed -e "s|#LIBDIR#|$(libdir)|g"         \
			-e "s|#ARMHF_ONLY#|$(armhf_only)|g" \
			-e "s|#ARM64_ONLY#|$(arm64_only)|g" \
			-e "s|#AMD64_ONLY#|$(amd64_only)|g" \
			-e "s|#I386_ONLY#|$(i386_only)|g" \
			-e "s|#PPC64EL_ONLY#|$(ppc64el_only)|g" \
			-e "s|#ARMHF_EXCLUDED#|$(armhf_excluded)|g" \
			-e "s|#ARM64_EXCLUDED#|$(arm64_excluded)|g" \
			-e "s|#AMD64_EXCLUDED#|$(amd64_excluded)|g" \
			-e "s|#I386_EXCLUDED#|$(i386_excluded)|g" \
			-e "s|#PPC64EL_EXCLUDED#|$(ppc64el_excluded)|g" \
			-e "s|#NVEXCLUDEMODULES#|$(DKMS_disabled_modules)|g" \
			-e "s|#FLAVOUR#|$(flavour)|g" \
			-e "s|#OTHER_FLAVOUR#|$(other_flavour)|g" \
			-e "s|#DRIVERNAME#|$(pkg_driver)|g" \
			-e "s|#VERSION#|$(version)|g" \
			-e "s|#DEBIAN_VERSION#|$(debian_version)|g" \
			-e "s|#MODULENAME#|$(version)|g" \
			-e "s|#DEB_HOST_MULTIARCH#|$(DEB_HOST_MULTIARCH)|g" \
			$$i > $$dest;      \
	done

############################################################################

CACHE			?= ../.cache
ORIGDIR			?= nvidia-graphics-drivers-$(version_major).orig
TARBALL_BASE		?= nvidia-graphics-drivers-$(version_major)_$(NVIDIA_RELEASE).orig
TARBALL_SUFFIX		?= .tar.gz
TARBALL			?= $(TARBALL_BASE)$(TARBALL_SUFFIX)
ORIGDIR.empty		?= $(ORIGDIR)
TARBALL.empty		?= $(TARBALL)

# $1 = arch
get_download_url	 = $(or $(HTTPURL_PREFIX_$(strip $1)),$(HTTPURL_PREFIX))/$(HTTPURL_ARCHDIR_$(strip $1))/$(NVIDIA_RELEASE)/$(NVIDIA_FILENAME_$(strip $1))
get_kern_download_url	= $(or $(HTTPURL_PREFIX_$(strip $1)),$(HTTPURL_PREFIX))/$(NVIDIA_FILENAME_$(strip $1))
get_origdir		 = $(or $(ORIGDIR.$(strip $1)),$(ORIGDIR)-$(strip $1))
get_tarball		 = $(or $(TARBALL.$(strip $1)),$(TARBALL_BASE)-$(strip $1)$(TARBALL_SUFFIX))

update-runtimepm-ids:
	python3 $(CURDIR)/debian/add-ids-to-json-db \
		NVIDIA-Linux/supported-gpus/supported-gpus.json \
		$(CURDIR)/debian/additional_runtimepm_ids \
		NVIDIA-Linux/supported-gpus/supported-gpus-mod.json

generate-runtimepm-aliases: update-runtimepm-ids

## nvidia-graphics-drivers-550 550.78

=== debian/changelog ===
nvidia-graphics-drivers-550 (550.78-0ubuntu0.20.04.1) focal; urgency=medium

  * New upstream release (LP: #2065302)

 -- Eduard de Vidal Flores <eduard.de.vidal.flores@canonical.com>  Thu, 23 May 2024 14:32:59 +0200

nvidia-graphics-drivers-550 (550.76-0ubuntu1.20.04.1) focal; urgency=medium

  * New upstream release (LP: #2063210)
  * Limit supported pci-id's to the new ones added by this release.
    (LP: #2061830)

 -- Bartlomiej Zolnierkiewicz <bartlomiej.zolnierkiewicz@canonical.com>  Fri, 26 Apr 2024 11:31:37 +0200

nvidia-graphics-drivers-550 (550.67-0ubuntu1.20.04.1) focal; urgency=medium

  * Initial release (LP: #2055384)

 -- Kuba Pawlak <kuba.pawlak@canonical.com>  Tue, 19 Mar 2024 20:50:29 +0100

=== debian/control ===
--- 
+++ 
@@ -20,7 +20,6 @@
  libkmod-dev,
  libpciaccess-dev,
  pkg-config,
- libnvidia-egl-wayland1,
  libc6,
  libx11-6,
  python3,
@@ -32,10 +31,10 @@
 Architecture: amd64 arm64
 Depends:
  libnvidia-gl-550 (= ${binary:Version}),
- nvidia-dkms-550 (<= 550.67-1),
- nvidia-dkms-550 (>= 550.67),
- nvidia-kernel-common-550 (<= 550.67-1),
- nvidia-kernel-common-550 (>= 550.67),
+ nvidia-dkms-550 (<= 550.78-1),
+ nvidia-dkms-550 (>= 550.78),
+ nvidia-kernel-common-550 (<= 550.78-1),
+ nvidia-kernel-common-550 (>= 550.78),
  nvidia-kernel-source-550 (= ${binary:Version}),
  libnvidia-compute-550 (= ${binary:Version}),
  libnvidia-extra-550 (= ${binary:Version}),
@@ -92,11 +91,11 @@
  nvidia-dkms-kernel
 Depends:
  dkms,
- nvidia-kernel-source-550 (<= 550.67-1),
- nvidia-kernel-source-550 (>= 550.67),
- nvidia-kernel-common-550 (<= 550.67-1),
- nvidia-kernel-common-550 (>= 550.67),
- nvidia-firmware-550-550.67,
+ nvidia-kernel-source-550 (<= 550.78-1),
+ nvidia-kernel-source-550 (>= 550.78),
+ nvidia-kernel-common-550 (<= 550.78-1),
+ nvidia-kernel-common-550 (>= 550.78),
+ nvidia-firmware-550-550.78,
  ${misc:Depends}, ${shlibs:Depends}
 Description: NVIDIA DKMS package
  This package builds the NVIDIA kernel module needed by the userspace
@@ -177,8 +176,8 @@
 Provides: nvidia-384
 Replaces: nvidia-384 (<< 390.25), nvidia-390 (<< 390.25-0ubuntu1)
 Depends:
- nvidia-kernel-common-550 (<= 550.67-1),
- nvidia-kernel-common-550 (>= 550.67),
+ nvidia-kernel-common-550 (<= 550.78-1),
+ nvidia-kernel-common-550 (>= 550.78),
  nvidia-kernel-source-550 (= ${binary:Version}),
  libnvidia-compute-550 (= ${binary:Version}),
  nvidia-compute-utils-550 (= ${binary:Version}),
@@ -215,7 +214,7 @@
 Conflicts: nvidia-kernel-common
 Provides: nvidia-kernel-common
 Depends:
- ${misc:Depends}, ${shlibs:Depends}, nvidia-firmware-550-550.67
+ ${misc:Depends}, ${shlibs:Depends}, nvidia-firmware-550-550.78
 Replaces:
  nvidia-dkms-550 (<< 390.48-0ubuntu3~), nvidia-kernel-common
 Description: Shared files used with the kernel module
@@ -226,12 +225,12 @@
  modules, and if you want udev to load the the NVIDIA kernel modules,
  and to create the uvm devices automatically.
 
-Package: nvidia-firmware-550-550.67
+Package: nvidia-firmware-550-550.78
 Architecture: amd64 arm64
 Breaks:
- nvidia-firmware-550-server-550.67
-Replaces:
- nvidia-firmware-550-server-550.67
+ nvidia-firmware-550-server-550.78
+Replaces:
+ nvidia-firmware-550-server-550.78
 Depends:
  ${misc:Depends}
 Description: Firmware files used by the kernel module
@@ -347,3 +346,5 @@
  libnvidia-compute-550 (= ${binary:Version}),
  ${shlibs:Depends}, ${misc:Depends}
 Conflicts:
+ libnvidia-decode,
+Replaces:

=== debian/rules ===
--- 
+++ 
@@ -178,7 +178,7 @@
 	dh_installinit --noscripts
 
 override_dh_shlibdeps:
-	LD_LIBRARY_PATH=/$(libdir):$(LD_LIBRARY_PATH) dh_shlibdeps -Xlibnvidia-pkcs11.so
+	LD_LIBRARY_PATH=/$(libdir):$(LD_LIBRARY_PATH) dh_shlibdeps -Xlibnvidia-pkcs11-openssl3.so
 
 override_dh_installsystemd:
 
@@ -244,4 +244,3 @@
 		$(CURDIR)/debian/additional_runtimepm_ids \
 		NVIDIA-Linux/supported-gpus/supported-gpus-mod.json
 
-generate-runtimepm-aliases: update-runtimepm-ids

## nvidia-graphics-drivers-550 550.90.07

=== debian/changelog ===
nvidia-graphics-drivers-550 (550.90.07-0ubuntu1) oracular; urgency=medium

  * New upstream release (LP: #2067881)

 -- Eduard de Vidal Flores <eduard.de.vidal.flores@canonical.com>  Mon, 03 Jun 2024 10:35:38 +0200

nvidia-graphics-drivers-550 (550.78-0ubuntu1) oracular; urgency=medium

  * New upstream release (LP: #2065302)

 -- Eduard de Vidal Flores <eduard.de.vidal.flores@canonical.com>  Thu, 23 May 2024 14:57:18 +0200

nvidia-graphics-drivers-550 (550.76-0ubuntu2) oracular; urgency=medium

  * change development branch to oracular, no binary release

 -- Kuba Pawlak <kuba.pawlak@canonical.com>  Tue, 07 May 2024 11:02:03 +0200

nvidia-graphics-drivers-550 (550.76-0ubuntu1) noble; urgency=medium

  * New upstream release (LP: #2063210)

 -- Bartlomiej Zolnierkiewicz <bartlomiej.zolnierkiewicz@canonical.com>  Tue, 23 Apr 2024 15:08:40 +0200

=== debian/control ===
--- 
+++ 
@@ -20,6 +20,7 @@
  libkmod-dev,
  libpciaccess-dev,
  pkg-config,
+ libnvidia-egl-wayland1,
  libc6,
  libx11-6,
  python3,
@@ -31,10 +32,10 @@
 Architecture: amd64 arm64
 Depends:
  libnvidia-gl-550 (= ${binary:Version}),
- nvidia-dkms-550 (<= 550.78-1),
- nvidia-dkms-550 (>= 550.78),
- nvidia-kernel-common-550 (<= 550.78-1),
- nvidia-kernel-common-550 (>= 550.78),
+ nvidia-dkms-550 (<= 550.90.07-1),
+ nvidia-dkms-550 (>= 550.90.07),
+ nvidia-kernel-common-550 (<= 550.90.07-1),
+ nvidia-kernel-common-550 (>= 550.90.07),
  nvidia-kernel-source-550 (= ${binary:Version}),
  libnvidia-compute-550 (= ${binary:Version}),
  libnvidia-extra-550 (= ${binary:Version}),
@@ -91,11 +92,11 @@
  nvidia-dkms-kernel
 Depends:
  dkms,
- nvidia-kernel-source-550 (<= 550.78-1),
- nvidia-kernel-source-550 (>= 550.78),
- nvidia-kernel-common-550 (<= 550.78-1),
- nvidia-kernel-common-550 (>= 550.78),
- nvidia-firmware-550-550.78,
+ nvidia-kernel-source-550 (<= 550.90.07-1),
+ nvidia-kernel-source-550 (>= 550.90.07),
+ nvidia-kernel-common-550 (<= 550.90.07-1),
+ nvidia-kernel-common-550 (>= 550.90.07),
+ nvidia-firmware-550-550.90.07,
  ${misc:Depends}, ${shlibs:Depends}
 Description: NVIDIA DKMS package
  This package builds the NVIDIA kernel module needed by the userspace
@@ -176,8 +177,8 @@
 Provides: nvidia-384
 Replaces: nvidia-384 (<< 390.25), nvidia-390 (<< 390.25-0ubuntu1)
 Depends:
- nvidia-kernel-common-550 (<= 550.78-1),
- nvidia-kernel-common-550 (>= 550.78),
+ nvidia-kernel-common-550 (<= 550.90.07-1),
+ nvidia-kernel-common-550 (>= 550.90.07),
  nvidia-kernel-source-550 (= ${binary:Version}),
  libnvidia-compute-550 (= ${binary:Version}),
  nvidia-compute-utils-550 (= ${binary:Version}),
@@ -214,7 +215,7 @@
 Conflicts: nvidia-kernel-common
 Provides: nvidia-kernel-common
 Depends:
- ${misc:Depends}, ${shlibs:Depends}, nvidia-firmware-550-550.78
+ ${misc:Depends}, ${shlibs:Depends}, nvidia-firmware-550-550.90.07
 Replaces:
  nvidia-dkms-550 (<< 390.48-0ubuntu3~), nvidia-kernel-common
 Description: Shared files used with the kernel module
@@ -225,12 +226,12 @@
  modules, and if you want udev to load the the NVIDIA kernel modules,
  and to create the uvm devices automatically.
 
-Package: nvidia-firmware-550-550.78
+Package: nvidia-firmware-550-550.90.07
 Architecture: amd64 arm64
 Breaks:
- nvidia-firmware-550-server-550.78
-Replaces:
- nvidia-firmware-550-server-550.78
+ nvidia-firmware-550-server-550.90.07
+Replaces:
+ nvidia-firmware-550-server-550.90.07
 Depends:
  ${misc:Depends}
 Description: Firmware files used by the kernel module
@@ -344,7 +345,3 @@
  ${misc:Pre-Depends}
 Depends:
  libnvidia-compute-550 (= ${binary:Version}),
- ${shlibs:Depends}, ${misc:Depends}
-Conflicts:
- libnvidia-decode,
-Replaces:

## nvidia-graphics-drivers-550 550.107.02

=== debian/changelog ===
nvidia-graphics-drivers-550 (550.107.02-0ubuntu3) questing; urgency=medium

  * Transitions old driver to 580 (LP: #2122017)

 -- Kuba Pawlak <kuba.pawlak@canonical.com>  Thu, 04 Sep 2025 17:05:15 +0200

nvidia-graphics-drivers-550 (550.107.02-0ubuntu2) oracular; urgency=medium

  * Add transitionals to 560 (LP: #2083677)

 -- Kuba Pawlak <kuba.pawlak@canonical.com>  Fri, 04 Oct 2024 12:06:08 +0200

nvidia-graphics-drivers-550 (550.107.02-0ubuntu1) oracular; urgency=medium

  * New upstream release (LP: #2075327)

 -- Eduard de Vidal Flores <eduard.de.vidal.flores@canonical.com>  Mon, 05 Aug 2024 10:49:10 +0200

nvidia-graphics-drivers-550 (550.100-0ubuntu2) oracular; urgency=medium

  * Add runtime dependency on libnvidia-egl-wayland1, needed to properly support wayland sessions (LP: #2062082)
  * Revert limiting supported pci-id's to the new ones supported by this release (LP: #2073109)

 -- Eduard de Vidal Flores <eduard.de.vidal.flores@canonical.com>  Mon, 15 Jul 2024 17:15:01 +0200

nvidia-graphics-drivers-550 (550.100-0ubuntu1) oracular; urgency=medium

  * New upstream release (LP: #2072571)

 -- Eduard de Vidal Flores <eduard.de.vidal.flores@canonical.com>  Tue, 09 Jul 2024 18:07:12 +0200

nvidia-graphics-drivers-550 (550.90.07-0ubuntu2) oracular; urgency=medium

  [ Paolo Pisati ]
  * Fix gcc-14 FTBFS (LP: #2075340) 

 -- Eduard de Vidal Flores <eduard.de.vidal.flores@canonical.com>  Thu, 01 Aug 2024 15:51:04 +0200

=== debian/control ===
Source: nvidia-graphics-drivers-550
Section: non-free/libs
Priority: optional
Maintainer: Ubuntu Core Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Uploaders:
 Alberto Milone <alberto.milone@canonical.com>,
Vcs-Git: git://github.com/canonical/nvidia-graphics-drivers.git
Vcs-Browser: https://github.com/canonical/nvidia-graphics-drivers/tree/550
Build-Depends:
 debhelper (>= 12),
 dpkg-dev (>= 1.17.11~),
 xz-utils,
 zstd,
 dkms,
 libxext6,
 po-debconf,
 dh-modaliases,
 xserver-xorg-dev (>= 2:1.4),
 libglvnd-dev,
 libkmod-dev,
 libpciaccess-dev,
 pkg-config,
 libnvidia-egl-wayland1,
 libc6,
 libx11-6,
 python3,
Standards-Version: 4.1.1
Homepage: http://www.nvidia.com
XS-Autobuild: yes

Package: nvidia-driver-550
Architecture: amd64 arm64
Section: non-free/oldlibs
Multi-Arch: no
Depends: nvidia-driver-580
Description: NVIDIA Server Driver metapackage (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: nvidia-kernel-source-550
Architecture: amd64 arm64
Section: non-free/oldlibs
Multi-Arch: foreign
Depends: nvidia-kernel-source-580
Description: NVIDIA kernel source package (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: nvidia-dkms-550
Architecture: amd64 arm64
Section: non-free/oldlibs
Multi-Arch: foreign
Depends: nvidia-dkms-580
Description: NVIDIA DKMS package (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: nvidia-utils-550
Architecture: amd64 arm64
Section: non-free/oldlibs
Multi-Arch: no
Depends: nvidia-utils-580
Description: NVIDIA Server Driver support binaries (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: libnvidia-compute-550
Architecture: i386 amd64 arm64
Section: non-free/oldlibs
Multi-Arch: same
Depends: libnvidia-compute-580
Description: NVIDIA libcompute package (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: nvidia-compute-utils-550
Architecture: amd64 arm64
Section: non-free/oldlibs
Multi-Arch: no
Depends: nvidia-compute-utils-580
Description: NVIDIA compute utilities (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: nvidia-headless-no-dkms-550
Architecture: amd64 arm64
Section: non-free/oldlibs
Multi-Arch: no
Depends: nvidia-headless-no-dkms-580
Description: NVIDIA headless metapackage - no DKMS (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: nvidia-headless-550
Architecture: amd64 arm64
Section: non-free/oldlibs
Multi-Arch: no
Depends: nvidia-headless-580
Description: NVIDIA headless metapackage (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: nvidia-kernel-common-550
Architecture: amd64 arm64
Section: non-free/oldlibs
Multi-Arch: no
Depends: nvidia-kernel-common-580
Description: Shared files used with the kernel module (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: libnvidia-gl-550
Architecture: i386 amd64 arm64
Section: non-free/oldlibs
Multi-Arch: same
Depends: libnvidia-gl-580
Description: NVIDIA OpenGL/GLX/EGL/GLES GLVND libraries and Vulkan ICD (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: libnvidia-common-550
Architecture: all
Section: non-free/oldlibs
Multi-Arch: foreign
Depends: libnvidia-common-580
Description: Shared files used by the NVIDIA libraries (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: libnvidia-extra-550
Architecture: i386 amd64 arm64
Section: non-free/oldlibs
Multi-Arch: same
Depends: libnvidia-extra-580
Description: Extra libraries for the NVIDIA Server Driver (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: xserver-xorg-video-nvidia-550
Architecture: amd64 arm64
Section: non-free/oldlibs
Multi-Arch: no
Depends: xserver-xorg-video-nvidia-580
Description: NVIDIA binary Xorg driver (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: libnvidia-cfg1-550
Architecture: amd64 arm64
Section: non-free/oldlibs
Multi-Arch: same
Depends: libnvidia-cfg1-580
Description: NVIDIA binary OpenGL/GLX configuration library (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: libnvidia-fbc1-550
Architecture: i386 amd64 arm64
Section: non-free/oldlibs
Multi-Arch: same
Depends: libnvidia-fbc1-580
Description: NVIDIA OpenGL-based Framebuffer Capture runtime library (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: libnvidia-decode-550
Architecture: i386 amd64 arm64
Section: non-free/oldlibs
Multi-Arch: same
Depends: libnvidia-decode-580
Description: NVIDIA Video Decoding runtime libraries (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: libnvidia-encode-550
Architecture: i386 amd64 arm64
Section: non-free/oldlibs
Multi-Arch: same
Depends: libnvidia-encode-580
Description: NVENC Video Encoding runtime library (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: nvidia-driver-550-open
Architecture: amd64 arm64
Section: non-free/oldlibs
Multi-Arch: no
Depends: nvidia-driver-580-open
Description: NVIDIA Server Driver metapackage (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: nvidia-kernel-source-550-open
Architecture: amd64 arm64
Section: non-free/oldlibs
Multi-Arch: foreign
Depends: nvidia-kernel-source-580-open
Description: NVIDIA kernel source package (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: nvidia-dkms-550-open
Architecture: amd64 arm64
Section: non-free/oldlibs
Multi-Arch: foreign
Depends: nvidia-dkms-580-open
Description: NVIDIA DKMS package (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: nvidia-headless-no-dkms-550-open
Architecture: amd64 arm64
Section: non-free/oldlibs
Multi-Arch: no
Depends: nvidia-headless-no-dkms-580-open
Description: NVIDIA headless metapackage - no DKMS (transitional package)
 Transitional package for upgrades. This package can be safely removed.

Package: nvidia-headless-550-open
Architecture: amd64 arm64
Section: non-free/oldlibs
Multi-Arch: no
Depends: nvidia-headless-580-open
Description: NVIDIA headless metapackage (transitional package)
 Transitional package for upgrades. This package can be safely removed.

=== debian/rules ===
--- 
+++ 
@@ -146,39 +146,11 @@
 override_dh_clean: regen-from-templates
 	dh_clean
 
-override_dh_auto_configure: prepare regen-from-templates
-
 override_dh_compress:
 	dh_compress -Xsupported-gpus.json
 
-override_dh_install: generate-modaliases build-device-create
-	# Use our custom dkms.conf file
-	cp -f $(CURDIR)/debian/dkms_nvidia.conf $(CURDIR)/debian/dkms.conf
-	cp -f $(CURDIR)/debian/dkms_nvidia_open.conf $(CURDIR)/debian/open-kernel/dkms.conf
-
-ifeq (,$(findstring nvidia-uvm,$(DKMS_disabled_modules)))
-	# Make sure the UVM module is built
-	cat $(CURDIR)/debian/dkms.conf.fragment >> $(CURDIR)/debian/dkms.conf
-	cat $(CURDIR)/debian/dkms.conf.fragment >> $(CURDIR)/debian/open-kernel/dkms.conf
-endif
-
-	dh_install -p nvidia-compute-utils-$(version_major)
-	mkdir -p $(CURDIR)/debian/nvidia-compute-utils-$(version_major)/lib/systemd
-	dh_installsystemd --name=nvidia-persistenced --no-start --no-stop-on-upgrade --no-restart-after-upgrade
-	dh_install -p nvidia-kernel-common-$(version_major)
-
-	mkdir -p $(CURDIR)/debian/nvidia-kernel-common-$(version_major)/lib/systemd
-	dh_installsystemd --name=nvidia-hibernate --no-start --no-stop-on-upgrade --no-restart-after-upgrade
-	dh_installsystemd --name=nvidia-resume --no-start --no-stop-on-upgrade --no-restart-after-upgrade
-	dh_installsystemd --name=nvidia-suspend --no-start --no-stop-on-upgrade --no-restart-after-upgrade
-
-	dh_install
-
 override_dh_installinit:
-	dh_installinit --noscripts
-
 override_dh_shlibdeps:
-	LD_LIBRARY_PATH=/$(libdir):$(LD_LIBRARY_PATH) dh_shlibdeps -Xlibnvidia-pkcs11-openssl3.so
 
 override_dh_installsystemd:
 
@@ -195,7 +167,7 @@
 				sed -e "s|flavour|*|g"`; \
 		rm -f $$old; done
 	# Create important strings
-	for i in debian/templates/*.in; do \
+	for i in debian/templates/control.in; do \
 		dest=`echo $$i | sed -e "s|templates\/||g" | \
 				 sed -e "s|\.in\$$||g" | \
 				 sed -e "s|version|$(version)|g" | \
@@ -244,3 +216,36 @@
 		$(CURDIR)/debian/additional_runtimepm_ids \
 		NVIDIA-Linux/supported-gpus/supported-gpus-mod.json
 
+generate-runtimepm-aliases: update-runtimepm-ids
+	python3 $(CURDIR)/debian/pm-aliases-gen \
+		NVIDIA-Linux/supported-gpus/supported-gpus-mod.json > $(CURDIR)/debian/runtimepm_ids
+	rm -f NVIDIA-Linux/supported-gpus/supported-gpus-mod.json
+
+override_dh_gencontrol:
+	dh_gencontrol -- -V'nvidia:Version=$(version)'
+
+generate-modaliases:
+	# Generate modaliases for the restricted drivers manager
+	mkdir -p $(CURDIR)/debian/$(pkg_meta)-modaliases/usr/share/jockey/modaliases/
+	mkdir -p $(CURDIR)/debian/$(pkg_meta_open)-modaliases/usr/share/jockey/modaliases/
+	python3 $(CURDIR)/debian/nvidia_supported \
+		$(pkg_module) $(pkg_meta) \
+		NVIDIA-Linux/supported-gpus/supported-gpus.json \
+		> $(CURDIR)/debian/$(pkg_meta).modaliases
+
+	python3 $(CURDIR)/debian/nvidia_supported \
+		$(pkg_module) $(pkg_meta_open) \
+		NVIDIA-Linux/supported-gpus/supported-gpus.json --open \
+		> $(CURDIR)/debian/$(pkg_meta_open).modaliases
+	# Take additional card ids from a text file
+	# Generate a modalias for each ID
+	@set -e -x ; \
+	while read line; do \
+		echo $$line | grep -Eq '^#.*' && continue; \
+		for id in $$line; do \
+			printf 'alias pci:v%08Xd%08Xsv*sd*bc03sc*i* %s %s\n' \
+				0x10de "0x$$id" "$(pkg_module)" "$(pkg_meta)"; \
+		done; \
+	done < $(CURDIR)/debian/additional_card_ids >>$(CURDIR)/debian/$(pkg_meta).modaliases
+	while read line; do \
+		echo $$line | grep -Eq '^#.*' && continue; \
